﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;

using System.Text.RegularExpressions;
using System.IO;
using System.Net;
using System.ComponentModel;

namespace MachrJazyky
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        BrushConverter bc = new BrushConverter();
        WebClient webClient = new WebClient();
        Hmotnost hmotnost = new Hmotnost();
        Delka delkaconv = new Delka();
        Data dataconv = new Data();


        System.Windows.Threading.DispatcherTimer myDispatcherTimer = new System.Windows.Threading.DispatcherTimer();
        bool st = true;

        List<string> vaha = new List<string>();
        List<string> delka = new List<string>();
        List<string> data = new List<string>();

        List<string> jazyky = new List<string>();



        List<string> jazyk1 = new List<string>();

        public MainWindow()
        {
            InitializeComponent();

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {

            //kolik.Text = hmotnost.Vysledek(hmotnost.PrevedNaZaklad("mm", int.Parse(z.Text)),"km").ToString();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            string cesta = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Prevodnik");
            string[] filePaths = Directory.GetFiles(cesta).Select(path => Path.GetFileName(path))
                                     .ToArray();


            foreach (string files in filePaths)
            {
                string afiles = files.Remove(files.Length - 4);
                jazyky.Add(afiles);
            }
            cbJa.ItemsSource = jazyky;


            UlJazyk.create();

            vaha.Add("g");
            vaha.Add("dkg");
            vaha.Add("kg");
            vaha.Add("t");

            delka.Add("mm");
            delka.Add("cm");
            delka.Add("m");
            delka.Add("km");

            data.Add("B");
            data.Add("KB");
            data.Add("MB");
            data.Add("GB");
            data.Add("TB");

            Z.ItemsSource = vaha;
            Do.ItemsSource = vaha;
            Z.SelectedIndex = 0;
            Do.SelectedIndex = 0;


            txtis.Text = "je";

            try
            {
                if (!jazyky.Contains("cj"))
                {

                    webClient.DownloadFileCompleted += new AsyncCompletedEventHandler(Completed);

                    webClient.DownloadFileAsync(new Uri("http://florbal-info.sweb.cz/aj.txt"), Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Prevodnik/" + "aj.txt"));

                }
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }


        }

        private void Completed(object sender, AsyncCompletedEventArgs e)
        {
            if (st == true)
            {

                webClient.DownloadFileAsync(new Uri("http://florbal-info.sweb.cz/svk.txt"), Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Prevodnik/" + "svk.txt"));
                st = false;
            }
            else
                webClient.DownloadFileAsync(new Uri("http://florbal-info.sweb.cz/cj.txt"), Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Prevodnik/" + "cj.txt"));

        }

        private void NumberValidationTextBox(object sender, TextCompositionEventArgs e) //Validace textboxu pouze na cisla
        {
            Regex regex = new Regex("[^0-9]+");
            e.Handled = regex.IsMatch(e.Text);
        }


        private void DeklaClick(object sender, MouseButtonEventArgs e)
        {
            dlka.Foreground = Brushes.White;

            Brush brush = (Brush)bc.ConvertFrom("#FF9E9E9E");
            brush.Freeze();
            hm.Foreground = brush;
            dta.Foreground = brush;

            Z.ItemsSource = delka;
            Do.ItemsSource = delka;
            Z.SelectedIndex = 0;
            Do.SelectedIndex = 0;
        }

        private void HmotnostClick(object sender, MouseButtonEventArgs e)
        {
            hm.Foreground = Brushes.White;

            Brush brush = (Brush)bc.ConvertFrom("#FF9E9E9E");
            brush.Freeze();
            dlka.Foreground = brush;
            dta.Foreground = brush;

            Z.ItemsSource = vaha;
            Do.ItemsSource = vaha;
            Z.SelectedIndex = 0;
            Do.SelectedIndex = 0;
        }

        private void DataClick(object sender, MouseButtonEventArgs e)
        {
            dta.Foreground = Brushes.White;

            Brush brush = (Brush)bc.ConvertFrom("#FF9E9E9E");
            brush.Freeze();
            dlka.Foreground = brush;
            hm.Foreground = brush;

            Z.ItemsSource = data;
            Do.ItemsSource = data;
            Z.SelectedIndex = 0;
            Do.SelectedIndex = 0;
        }

        private void BntConvert_Click(object sender, RoutedEventArgs e)
        {


            if (hm.Foreground == Brushes.White)
            {

                txtvystup.Text = hmotnost.Vysledek(hmotnost.PrevedNaZaklad(int.Parse(txtVstup.Text), Z.SelectedItem.ToString()), Do.SelectedItem.ToString()) + " " + Do.SelectedItem.ToString();

            }
            else if (dlka.Foreground == Brushes.White)
            {
                txtvystup.Text = delkaconv.Vysledek(delkaconv.PrevedNaZaklad(int.Parse(txtVstup.Text), Z.SelectedItem.ToString()), Do.SelectedItem.ToString()).ToString() + " " + Do.SelectedItem.ToString();

            }

            else
            {
                txtvystup.Text = dataconv.Vysledek(dataconv.PrevedNaZaklad(int.Parse(txtVstup.Text), Z.SelectedItem.ToString()), Do.SelectedItem.ToString()).ToString() + " " + Do.SelectedItem.ToString();

            }

            txtVysledek.Text = txtVstup.Text + " " + Z.SelectedItem.ToString();

        }





        private void prJazyk_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Window1 wn = new Window1();
            wn.Show();
        }

        public void ZmenJazyk(string soubor)
        {
            using (StreamReader r = new StreamReader((Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Prevodnik/" + soubor + ".txt")), Encoding.Default))
            {

                string line;
                while ((line = r.ReadLine()) != null)
                {
                    jazyk1.Add(line);
                }
            }

            hm.Text = jazyk1[0];
            dlka.Text = jazyk1[1];
            dta.Text = jazyk1[2];
            prevestZ.Text = jazyk1[3];
            prevestDo.Text = jazyk1[4];
            BntConvert.Content = jazyk1[5];
            jazyk.Text = jazyk1[6];
            txtis.Text = jazyk1[7];
            prJazyk.Text = jazyk1[8];
            jazyk1.Clear();
        }

        private void cbJa_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ZmenJazyk(cbJa.SelectedItem.ToString());
        }

    }
}
