﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Prevodnik
{
    class ConvertorCubic : Convertor
    {
        protected Dictionary<string, double> units = new Dictionary<string, double>()
        {
            {"mm3", Math.Pow(10,-9)},
	        {"cm3", Math.Pow(10,-6)},
            {"cuin", Math.Pow(0.0254,3)},
            {"dm3", Math.Pow(10,-3)},
            {"ml", Math.Pow(10,-6)},
            {"cl", Math.Pow(10,-5)},
            {"dl", Math.Pow(10,-4)},
	        {"l", Math.Pow(10,-3)},
            {"cuft.", Math.Pow(0.3048,3)},
	        {"m3", 1},
            {"km3", Math.Pow(10,9)}
        };
        protected string type = "cubic";
        public override Dictionary<string, double> GetUnits()
        {
            return units;
        }
        public override string GetType()
        {
            return type;
        }
        public override string Convert(double number, string from, string target)
        {
            if (!units.ContainsKey(target))
                return "";
            if (from == target)
                return number + target;
            double temp;
            //Desetina carka
            int dot;
            if (number.ToString().Contains("."))
                dot = number.ToString().Length - number.ToString().IndexOf('.');
            else
                dot = 0;
            units.TryGetValue(from, out temp);
            if (temp != 1)
            {
                number *= temp;
            }
            if (units.ContainsKey(target))
            {
                units.TryGetValue(target, out temp);
                number /= temp;
                number /= Math.Pow(10, dot);
                return number + target;
            }
            return "";
        }
    }
}
