﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Prevodnik
{
    class ConvertorData : Convertor
    {
        protected Dictionary<string, double> units = new Dictionary<string, double>()
        {
            {"b", 0.125},
            {"B", 1},
	        {"kB", 1024},
	        {"MB", Math.Pow(1024,2)},
	        {"GB", Math.Pow(1024,3)},
            {"TB", Math.Pow(1024,4)},
            {"PB", Math.Pow(1024,5)}
        };
        protected string type = "data";
        public override Dictionary<string, double> GetUnits()
        {
            return units;
        }
        public override string GetType()
        {
            return type;
        }
        public override string Convert(double number, string from, string target)
        {
            if (!units.ContainsKey(target))
                return "";
            if (from == target)
                return number+target;
            double temp;
            int dot;
            if (number.ToString().Contains("."))
                dot = number.ToString().Length - number.ToString().IndexOf('.');
            else
                dot = 0;
            units.TryGetValue(from, out temp);
            if (temp != 1)
            {
                number *= temp;
            }
            if (units.ContainsKey(target))
            {
                units.TryGetValue(target, out temp);
                number /= temp;
                number /= Math.Pow(10, dot);
                return number + target;
            }
            return "";
        }
    }
}
