﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Prevodnik
{
    class ConvertorDistance : Convertor
    {
        protected Dictionary<string, double> units = new Dictionary<string, double>()
        {
            {"mm", 0.001},
	        {"cm", 0.01},
            {"in", 0.0254},
	        {"dm", 0.1},
            {"ft", 0.3048},
	        {"m", 1},
            {"km", 1000}
        };
        protected string type = "distance";
        public override Dictionary<string, double> GetUnits()
        {
            return units;
        }
        public override string GetType()
        {
            return type;
        }
        public override string Convert(double number, string from, string target)
        {
            if (!units.ContainsKey(target))
                return "";
            if (from == target)
                return number + target;
            double temp;
            //Desetina carka
            int dot;
            if (number.ToString().Contains("."))
                dot = number.ToString().Length - number.ToString().IndexOf('.');
            else
                dot = 0;
            units.TryGetValue(from, out temp);
            if (temp != 1)
            {
                number *= temp;
            }
            if (units.ContainsKey(target))
            {
                units.TryGetValue(target, out temp);
                number /= temp;
                number /= Math.Pow(10, dot);
                return number + target;
            }
            return "";
        }
    }
}
