﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Prevodnik
{
    class ConvertorSquared : Convertor
    {
        protected Dictionary<string, double> units = new Dictionary<string, double>()
        {
            {"mm2", 0.000001},
	        {"cm2", 0.0001},
            {"sqin", Math.Pow(0.0254,2)},
	        {"dm2", 0.01},
            {"sqft", Math.Pow(0.3048,2)},
	        {"m2", 1},
            {"ar", 100},
            {"ha", 10000},
            {"km2", 1000000}
        };
        protected string type = "squared";
        public override Dictionary<string, double> GetUnits()
        {
            return units;
        }
        public override string GetType()
        {
            return type;
        }
        public override string Convert(double number, string from, string target)
        {
            if (!units.ContainsKey(target))
                return "";
            if (from == target)
                return number + target;
            double temp;
            //Desetina carka
            int dot;
            if (number.ToString().Contains("."))
                dot = number.ToString().Length - number.ToString().IndexOf('.');
            else
                dot = 0;
            units.TryGetValue(from, out temp);
            if (temp != 1)
            {
                number *= temp;
            }
            if (units.ContainsKey(target))
            {
                units.TryGetValue(target, out temp);
                number /= temp;
                number /= Math.Pow(10, dot);
                return number + target;
            }
            return "";
        }
    }
}
