﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Prevodnik
{
    class ConvertorWeight : Convertor
    {
        protected Dictionary<string, double> units = new Dictionary<string, double>()
        {
            {"mg", 0.000001},
            {"g", 0.001},
	        {"dkg", 0.01},
            {"lb", 0.4535},
	        {"kg", 1},
            {"q", 100},
	        {"t", 1000}
        };
        protected string type = "weight";
        public override Dictionary<string, double> GetUnits()
        {
            return units;
        }
        public override string GetType()
        {
            return type;
        }
        public override string Convert(double number, string from, string target)
        {
            if (!units.ContainsKey(target))
                return "";
            if (from == target)
                return number + target;
            double temp;
            int dot;
            if (number.ToString().Contains("."))
                dot = number.ToString().Length - number.ToString().IndexOf('.');
            else
                dot = 0;
            units.TryGetValue(from, out temp);
            if (temp != 1)
            {
                number *= temp;
            }
            if (units.ContainsKey(target))
            {
                units.TryGetValue(target, out temp);
                number /= temp;
                number /= Math.Pow(10, dot);
                return number + target;
            }
            return "";
        }
    }
}
