﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Prevodnik
{
    /// <summary>
    /// Interaction logic for HelpWindow.xaml
    /// </summary>
    public partial class HelpWindow : Window
    {
        public HelpWindow(List<string> units, List<string> languages, string activeLang)
        {
            InitializeComponent();
            foreach (string s in languages)
                LangsListBox.Items.Add(s);

            foreach (string s in units)
                UnitsListBox.Items.Add(s);

            SetLanguageDictionary(activeLang);
        }
        /// <summary>
        /// Nastavi jazyk
        /// </summary>
        /// <param name="lang">language to set</param>
        private void SetLanguageDictionary(string lang)
        {
            ResourceDictionary dict = new ResourceDictionary();
            string path = "..\\Localization\\{0}.xaml";
            dict.Source = new Uri(String.Format(path, lang), UriKind.Relative);
            Resources.MergedDictionaries.Add(dict);
        }
    }
}
