﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PrevodnikJednotek
{
    /// <summary>
    /// Convertor for measuring units
    /// </summary>
    class DataUnitsConvertor: IConvertor
    {
        /// <summary>
        /// The basic number on which this system is built
        /// </summary>
        private int baseNumber = 1024;
        /// <summary>
        /// Convert unit
        /// </summary>
        /// <param name="value">Value of original unit</param>
        /// <param name="fromUnit">Original unit</param>
        /// <param name="toUnit">To convert unit</param>
        /// <returns>Converted number</returns>
        public double Convert(double value, int fromUnit, int toUnit)
        {
            return value * Math.Pow(baseNumber, fromUnit - toUnit);
        }
        /// <summary>
        /// Get dictionary which contains name of units and their exponent of base number
        /// </summary>
        /// <returns>Units and their exponents</returns>
        public Dictionary<string, int> GetUnits()
        {
            Dictionary<string, int> multipleUnits = new Dictionary<string, int>();
            multipleUnits.Add("B", 0);
            multipleUnits.Add("KB", 1);
            multipleUnits.Add("MB", 2);
            multipleUnits.Add("GB", 3);
            multipleUnits.Add("TB", 4);
            return multipleUnits;
        }
    }
}
