﻿namespace Konvertor
{
    class Jednotka
    {
        public static Jednotka Mili = new Jednotka("m", 0.001m);
        public static Jednotka Centi = new Jednotka("c", 0.01m);
        public static Jednotka Deci = new Jednotka("d", 0.1m);
        public static Jednotka Zaklad = new Jednotka("", 1m);
        public static Jednotka DeciKilo = new Jednotka("dk", 100m);
        public static Jednotka Kilo = new Jednotka("k", 1000m);
        public static Jednotka Tuna = new Jednotka("t", 1000000m, false);
        public static Jednotka Mega = new Jednotka("M", 1000000m);
        public static Jednotka Giga = new Jednotka("G", 1000000000m);
        public static Jednotka Tera = new Jednotka("T", 1000000000000m);
        public static Jednotka Kibi = new Jednotka("ki", 1024m);
        public static Jednotka Mebi = new Jednotka("Mi", 1048576m);
        public static Jednotka Gibi = new Jednotka("Gi", 1073741824m);
        public static Jednotka Tebi = new Jednotka("Ti", 1099511627776m);
        /// <summary>
        /// Znak jednotky
        /// </summary>
        public string Znak { get; private set; }
        /// <summary>
        /// Jaky nasobek jednotka vyjadruje
        /// </summary>
        public decimal Nasobek { get; private set; }
        private readonly bool _vypisovatZnacku;

        /// <summary>
        /// Reprezentuje jednotku
        /// </summary>
        /// <param name="znak">Znak pro jednotku</param>
        /// <param name="nasobek">Nasobek ktery jednotka vyjadruje</param>
        /// <param name="vypisovatZnacku">Ma se zobrazovat i znacka veliciny</param>
        public Jednotka(string znak, decimal nasobek, bool vypisovatZnacku = true)
        {
            Znak = znak;
            Nasobek = nasobek;
            _vypisovatZnacku = vypisovatZnacku;
        }

        /// <summary>
        /// Vypise znacku
        /// </summary>
        /// <param name="znacka">Znacka veliciny</param>
        /// <returns>Jednotka s/bez znacky veliciny</returns>
        public string Vypis(string znacka)
        {
            string vypis = Znak;
            if (_vypisovatZnacku)
                vypis += znacka;
            return vypis;
        }
    }
}
