﻿using System.Collections.Generic;
using System.Linq;

namespace Konvertor
{
    class Konvertor
    {
        public readonly List<Velicina> Veliciny = new List<Velicina>(); 

        /// <summary>
        /// Stara se o prevod a take uchovava povolene jednotky pro kazdou z kategorii
        /// </summary>
        public Konvertor()
        {
            List<Jednotka> vaha = new List<Jednotka>();
            List<Jednotka> vzdalenost = new List<Jednotka>();
            List<Jednotka> bajty = new List<Jednotka>();
            vaha.Add(Jednotka.Zaklad);
            vaha.Add(Jednotka.DeciKilo);
            vaha.Add(Jednotka.Kilo);
            vaha.Add(Jednotka.Tuna);
            vzdalenost.Add(Jednotka.Mili);
            vzdalenost.Add(Jednotka.Centi);
            vzdalenost.Add(Jednotka.Zaklad);
            vzdalenost.Add(Jednotka.Kilo);
            bajty.Add(Jednotka.Zaklad);
            bajty.Add(Jednotka.Kilo);
            bajty.Add(Jednotka.Mega);
            bajty.Add(Jednotka.Giga);
            bajty.Add(Jednotka.Tera);
            bajty.Add(Jednotka.Kibi);
            bajty.Add(Jednotka.Mebi);
            bajty.Add(Jednotka.Gibi);
            bajty.Add(Jednotka.Tebi);
            vaha = vaha.OrderBy(x => x.Nasobek).ToList();
            vzdalenost = vzdalenost.OrderBy(x => x.Nasobek).ToList();
            bajty = bajty.OrderBy(x => x.Nasobek).ToList();
            Veliciny.Add(new Velicina(vaha, "g", "vaha"));
            Veliciny.Add(new Velicina(vzdalenost, "m", "vzdalenost"));
            Veliciny.Add(new Velicina(bajty, "B", "bajty"));
        }


        /// <summary>
        /// Prevede hodnotu
        /// </summary>
        /// <param name="hodnota">Hodnota, ktera se prevadi</param>
        /// <param name="zJednotky">Jednotka, z ktere se prevadi</param>
        /// <param name="doJednotky">Jednotka do, ktere se prevadi</param>
        /// <returns></returns>
        public string Konvertuj(decimal hodnota, Jednotka zJednotky, Jednotka doJednotky)
        {
            decimal nasobek = zJednotky.Nasobek / doJednotky.Nasobek;
            return (hodnota*nasobek).ToString("G29");
        }

        /// <summary>
        /// Vrati list jednote, ktere jsou povoleny pro danou velicinu
        /// </summary>
        /// <param name="znacka">Znacka veliciny</param>
        /// <returns></returns>
        public Velicina VelicinaZeZnacky(string znacka)
        {
            foreach (Velicina velicina in Veliciny){
                if (velicina.Znacka == znacka)
                    return velicina;
            }
            return Veliciny[0];
        }
    }
}
